#include "testx.h"
#include <QtWidgets>
#include <QVBoxLayout>

Testx::Testx(QWidget *parent)
    : QWidget(parent)
{
    QVBoxLayout *layout = new QVBoxLayout;

    setLayout(layout);

    setWindowTitle(tr("TESTx"));

	QFrame *frame = new QFrame();
	frame->setFrameShadow(QFrame::Raised);
	frame->setFrameShape(QFrame::StyledPanel);
	frame->setObjectName("INDIGO_property");

	QVBoxLayout* vbox = new QVBoxLayout();
	vbox->addWidget(frame);
	layout->addLayout(vbox);

	QVBoxLayout* frame_layout = new QVBoxLayout();
	frame->setLayout(frame_layout);

	QWidget *head = new QWidget();
	head->setObjectName("INDIGO_property");
	frame_layout->addWidget(head);
	QHBoxLayout* head_layout = new QHBoxLayout();
	head->setLayout(head_layout);

	head_layout->setAlignment(Qt::AlignLeft);
	head_layout->setMargin(3);
	head_layout->setSpacing(5);

	char device_string[1025];
	sprintf(device_string, "@ %s", "Test");

	QLabel* property_label = new QLabel("Test");
	property_label->setStyleSheet("font-weight: bold;");
	property_label->setObjectName("INDIGO_property");
	QLabel* device_label = new QLabel(device_string);
	device_label->setObjectName("INDIGO_property");

	head_layout->addWidget(property_label);
	head_layout->addWidget(device_label);

	QWidget *property_setings = new QWidget();
	property_setings->setObjectName("INDIGO_property");
	head_layout->addWidget(property_setings);
	QVBoxLayout* property_layout = new QVBoxLayout();
	property_setings->setLayout(property_layout);

	build_buttons(frame_layout);
}


void Testx::build_buttons(QVBoxLayout* layout) {

	//  Create a button box
	QHBoxLayout* hbox = new QHBoxLayout();
	layout->addLayout(hbox);
	hbox->setAlignment(Qt::AlignRight);
	hbox->setSpacing(10);
	hbox->setMargin(0);

	//  Add buttons
	QPushButton* set = new QPushButton("&Set");
	set->setObjectName("INDIGO_property");
	QPushButton* reset = new QPushButton("&Reset");
	reset->setObjectName("INDIGO_property");
	set->setDefault(true);
	set->setMinimumWidth(75);
	reset->setMinimumWidth(75);
	hbox->addWidget(reset);
	hbox->addWidget(set);

	//  Connect signals
	connect(set, &QPushButton::clicked, this, &Testx::backspaceClicked);
	connect(reset, &QPushButton::clicked, this, &Testx::backspaceClicked);
}


void Testx::backspaceClicked()
{
	static bool set = false;
	if (set) {
		this->setStyleSheet(
			"#INDIGO_property { background-color: #00AA00; border: 0px}"
			"QLineEdit#INDIGO_property { background-color: #00AA00}"
			"QPushButton#INDIGO_property { background-color: #225022 }"
			"QPushButton#INDIGO_property:focus { background-color: #225022 }"
		);
		set = false;
	} else {
		this->setStyleSheet(
			"#INDIGO_property { background-color: #AA0000; border: 0px}"
			"QLineEdit#INDIGO_property { background-color: #AA0000}"
			"QPushButton#INDIGO_property { background-color: #450000 }"
			"QPushButton#INDIGO_property:focus { background-color: #500000 }"
		);
		set = true;
	}
}
